<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<!-- 
IGAC proyecto SNC
@author:        juan.agudelo
@modified       pedro.garcia            uso de nuevo parámetro updatesBotonGuardarTramiteParam
                christian.rodriguez
@version        2.0
@cu             CU-CO-E-02

    Pantalla que permite adicionar un nuevo trámite asocaido al trámite seleccionado
 
    parámetros de entrada:
    -managedBeanParam: 			Nombre del ManagedBean del que se obtendran los parametros
    -selectedTramiteParam: 		Objeto de tipo Tramite que almacenará los valores de trámite 
                                en el formulario de Solicitud 
    -selectedTramiteTraParam: 	Objeto de tipo Trámite asociado a un Trámite que almacenará los 
                                valores de trámite en el formulario de Solicitud 
    -prediosTramiteParam:   	Lista de Predio que almacenará los valores de los predios asociados
                                a un trámite

@param updatesBotonGuardarTramiteParam lista de ids de componentes que se deben actualizar al dar click
        en el botón de adicionar el trámite
-->

<h:form xmlns="http://www.w3.org/1999/xhtml"
        xmlns:h="http://java.sun.com/jsf/html"
        xmlns:f="http://java.sun.com/jsf/core"
        xmlns:ui="http://java.sun.com/jsf/facelets"
        xmlns:p="http://primefaces.org/ui"
        xmlns:fn="http://java.sun.com/jsp/jstl/functions"
        id="nuevoTramiteSolForm">
    <h:panelGrid width="100%">

        <h:inputText id="errorFocus" style="border:0px;height:0;" />
        <p:messages id="msgsTramite" showDetail="false" globalOnly="false" />

        <h:panelGrid id="panelEdicionTramite" width="100%" cellspacing="7">
            <h:panelGrid columns="6" width="100%" cellspacing="7">

                <h:panelGrid columns="2">
                    <h:outputLabel value="Fuente: " for="TramiteFuente-3"
                                   styleClass="outputLabelStyle" />
                    <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                </h:panelGrid>
                <h:outputText id="TramiteFuente-3"
                              value="#{selectedTramiteTraParam.fuente}"
                              style="position:relative;left:3px;" styleClass="outputTextStyle">
                    <f:converter converterId="converterCB" for="TramiteFuente-3" />
                </h:outputText>

                <h:panelGrid columns="2">
                    <h:outputLabel value="Tipo de trámite: " for="tipoTramite"
                                   styleClass="outputLabelStyle" />
                    <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                </h:panelGrid>
                <h:panelGrid columns="2">
                    <h:selectOneMenu id="tipoTramite" required="true"
                                     label="Tipo de trámite" disabled="#{managedBeanParam.banderaVerTramitePorAsociar}"
                                     value="#{selectedTramiteTraParam.tipoTramite}">
                        <f:selectItem itemLabel="Seleccionar..." />
                        <f:selectItems
                            value="#{managedBeanParam.tiposTramitePorSolicitud}" />
                        <p:ajax immediate="false"
                                listener="#{managedBeanParam.cambioTipoTramite}"
                                update="claseMutacion, subtipo, msgsTramite, 
                                nuevoTramiteSolForm, contenedorPredios, panelEdicionTramite, 
                                contenedorDatosRectificarResumen" />
                    </h:selectOneMenu>
                    <p:message for="tipoTramite" display="icon" />
                </h:panelGrid>

                <h:panelGrid columns="2"
                             rendered="#{selectedTramiteTraParam.mutacion}">
                    <h:outputLabel value="Clase de mutación: " for="claseMutacion"
                                   styleClass="outputLabelStyle" />
                    <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                </h:panelGrid>
                <h:selectOneMenu id="claseMutacion"
                                 rendered="#{selectedTramiteTraParam.mutacion}" 
                                 disabled="#{managedBeanParam.banderaVerTramitePorAsociar}"
                                 value="#{selectedTramiteTraParam.claseMutacion}"
                                 required="true" requiredMessage="La clase de mutación es un campo obligatorio" 
                                 style="position:relative;left:3px;">
                    <f:selectItem itemLabel="Seleccionar..." noSelectionOption="true"/>
                    <f:selectItems value="#{managedBeanParam.mutacionClases}"></f:selectItems>
                    <p:ajax process="@this"
                            update="subtipo, subtipoTramReqOL, msgsTramite, nuevoTramiteSolForm,
                            contenedorPredios, panelEdicionTramite, Cons, prediosSelBtn, asignPrediosBtn"
                            listener="#{managedBeanParam.cambioClaseMutacion}" />
                </h:selectOneMenu>

                <h:panelGroup
                    rendered="#{managedBeanParam.subtipoTramiteEsRequerido}">
                    <h:outputLabel value="Subclase: " for="subtipo"
                                   styleClass="outputLabelStyle"
                                   rendered="#{managedBeanParam.subtipoTramiteEsRequerido}" />
                    <h:outputLabel value="*" styleClass="requiredLabelStyle"
                                   id="subtipoTramReqOL"
                                   rendered="#{managedBeanParam.subtipoTramiteEsRequerido}" />
                </h:panelGroup>

                <h:selectOneMenu id="subtipo"
                                 value="#{selectedTramiteTraParam.subtipo}" disabled="#{managedBeanParam.banderaVerTramitePorAsociar}"
                                 rendered="#{managedBeanParam.subtipoTramiteEsRequerido}"
                                 required="#{managedBeanParam.subtipoTramiteEsRequerido}"
                                 style="position:relative;left:4px;">
                    <f:selectItems value="#{managedBeanParam.subtipoClaseMutacionV}"></f:selectItems>
                    <p:ajax process="@this" update="tblPredios, mQuintaL, Cons, prediosSelBtn, asignPrediosBtn, contenedorPredios"
                            listener="#{managedBeanParam.actualizarDesdeSubtipo}"></p:ajax>
                    <p:message for="subtipo" display="icon" id="reqSubtipoTramite" />
                </h:selectOneMenu>

                <h:outputText
                    rendered="#{!managedBeanParam.subtipoTramiteEsRequerido and !selectedTramiteTraParam.esRectificacion}" />
                <h:outputText
                    rendered="#{!managedBeanParam.subtipoTramiteEsRequerido and !selectedTramiteTraParam.esRectificacion}" />
                <h:outputText
                    rendered="#{(selectedTramiteTraParam.esRectificacion or selectedTramiteTraParam.mutacion) and !managedBeanParam.subtipoTramiteEsRequerido}" />
                <h:outputText
                    rendered="#{(selectedTramiteTraParam.esRectificacion or selectedTramiteTraParam.mutacion) and !managedBeanParam.subtipoTramiteEsRequerido}" />
                <h:outputText
                    rendered="#{selectedTramiteTraParam.mutacion and !managedBeanParam.subtipoTramiteEsRequerido}" />
                <h:outputText
                    rendered="#{selectedTramiteTraParam.mutacion and !managedBeanParam.subtipoTramiteEsRequerido}" />


                <h:outputLabel value="Departamento:" for="departamentoL"
                               styleClass="outputLabelStyle" rendered="true" />
                <h:outputText value="#{selectedTramiteTraParam.departamento.nombre}"
                              styleClass="outputTextStyle" id="departamentoL" rendered="true" />

                <h:outputLabel value="Municipio: " for="municipioL"
                               styleClass="outputLabelStyle" rendered="true" />
                <h:outputText value="#{selectedTramiteTraParam.municipio.nombre}"
                              styleClass="outputTextStyle" id="municipioL" rendered="true" />

            </h:panelGrid>

            <h:panelGrid columns="5" id="mQuintaL"
                         rendered="#{selectedTramiteTraParam.quinta}">

                <h:panelGrid columns="16">

                    <h:outputLabel value="Número predial: "
                                   styleClass="outputLabelStyle" style="position:relative;left:-1px;" />

                    <p:spacer width="19" height="0" />

                    <h:inputText id="s1" value="#{managedBeanParam.numeroPredialParte1}" 
                                 disabled="#{managedBeanParam.banderaVerTramitePorAsociar}"
                                 readonly="#{managedBeanParam.banderaSubtipoNuevo}" size="1" maxlength="2" 
                                 onkeyup="saltar(this, 2, 2, 3, 'nuevoTramiteSolForm:');"
                                 onblur="complete(this, 2)" />
                    <h:inputText id="s2" value="#{managedBeanParam.numeroPredialParte2}"
                                 readonly="#{managedBeanParam.banderaSubtipoNuevo}" size="1" maxlength="3" 
                                 onkeyup="saltar(this, 3, 3, 2, 'nuevoTramiteSolForm:');"
                                 disabled="#{managedBeanParam.banderaVerTramitePorAsociar}"
                                 />
                    <h:inputText id="s3" value="#{managedBeanParam.numeroPredialParte3}"
                                 size="1" maxlength="2" 
                                 disabled="#{managedBeanParam.banderaVerTramitePorAsociar}"
                                 onkeyup="saltar(this, 2, 4, 2, 'nuevoTramiteSolForm:');"
                                 onblur="complete(this, 2)" />
                    <h:inputText id="s4" value="#{managedBeanParam.numeroPredialParte4}"
                                 size="1" maxlength="2" 
                                 disabled="#{managedBeanParam.banderaVerTramitePorAsociar}"
                                 onkeyup="saltar(this, 2, 5, 2, 'nuevoTramiteSolForm:');"
                                 onblur="complete(this, 2)" />
                    <h:inputText id="s5" value="#{managedBeanParam.numeroPredialParte5}"
                                 size="1" maxlength="2" 
                                 disabled="#{managedBeanParam.banderaVerTramitePorAsociar}"
                                 onkeyup="saltar(this, 2, 6, 2, 'nuevoTramiteSolForm:');"
                                 onblur="complete(this, 2)" />
                    <h:inputText id="s6" value="#{managedBeanParam.numeroPredialParte6}"
                                 size="1" maxlength="2" 
                                 disabled="#{managedBeanParam.banderaVerTramitePorAsociar}"
                                 onkeyup="saltar(this, 2, 7, 4, 'nuevoTramiteSolForm:');"
                                 onblur="complete(this, 2)" />
                    <h:inputText id="s7" value="#{managedBeanParam.numeroPredialParte7}"
                                 size="1" maxlength="4" 
                                 disabled="#{managedBeanParam.banderaVerTramitePorAsociar}"
                                 onkeyup="saltar(this, 4, 8, 4, 'nuevoTramiteSolForm:');"
                                 onblur="complete(this, 4)" />
                    <h:inputText id="s8" value="#{managedBeanParam.numeroPredialParte8}"
                                 readonly="#{managedBeanParam.banderaSubtipoNuevo}" size="1" maxlength="4"
                                 disabled="#{managedBeanParam.banderaVerTramitePorAsociar}"
                                 onkeyup="saltar(this, 4, 9, 1, 'nuevoTramiteSolForm:');"
                                 onblur="complete(this, 4)" />
                    <h:inputText id="s9" value="#{managedBeanParam.numeroPredialParte9}"
                                 readonly="#{managedBeanParam.banderaSubtipoNuevo}" size="1" maxlength="1"
                                 disabled="#{managedBeanParam.banderaVerTramitePorAsociar}"
                                 onkeyup="saltar(this, 1, 10, 2, 'nuevoTramiteSolForm:');"
                                 onblur="complete(this, 1)" />
                    <h:inputText id="s10" value="#{managedBeanParam.numeroPredialParte10}"
                                 readonly="#{managedBeanParam.banderaSubtipoNuevo}" size="1" maxlength="2"
                                 disabled="#{managedBeanParam.banderaVerTramitePorAsociar}"
                                 onkeyup="saltar(this, 2, 11, 2, 'nuevoTramiteSolForm:');"
                                 onblur="complete(this, 2)" />
                    <h:inputText id="s11" value="#{managedBeanParam.numeroPredialParte11}"
                                 readonly="#{managedBeanParam.banderaSubtipoNuevo}" size="1" maxlength="2"
                                 disabled="#{managedBeanParam.banderaVerTramitePorAsociar}"
                                 onkeyup="saltar(this, 2, 12, 4, 'nuevoTramiteSolForm:');"
                                 onblur="complete(this, 2)" />
                    <h:inputText id="s12" value="#{managedBeanParam.numeroPredialParte12}"
                                 readonly="#{managedBeanParam.banderaSubtipoNuevo}" size="1" maxlength="4"
                                 disabled="#{managedBeanParam.banderaVerTramitePorAsociar}"
                                 onblur="complete(this, 4)" />

                </h:panelGrid>

                <p:spacer width="2" height="0" />

                <h:panelGrid columns="2">
                    <h:outputLabel value="Área: " styleClass="outputLabelStyle" />
                    <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                </h:panelGrid>

                <p:spacer width="13" height="0" />
                <h:panelGrid columns="2">
                    <h:inputText value="#{selectedTramiteTraParam.areaTerreno}"
                                 label="Área" disabled="#{managedBeanParam.banderaVerTramitePorAsociar}"
                                 styleClass="outputTextStyle" id="numeroRad" required="true" />
                    <p:message for="numeroRad" display="icon"></p:message>
                </h:panelGrid>

            </h:panelGrid>
        </h:panelGrid>

        <h:panelGrid columns="3" id="contenedorDatosRectificarResumen"
                     width="100%" rendered="#{selectedTramiteTraParam.esRectificacion or selectedTramiteTraParam.esComplementacion}">
            <p:dataTable id="tblDatosRectificarResumen"
                         emptyMessage="No se han adicionado datos para rectificar o complementar"
                         value="#{managedBeanParam.selectedDatosRectifComplDataTable}"
                         var="datoRectifComplTabla"
                         rowKey="#{datoRectifComplTabla.id}">

                <f:facet name="header">
                    Datos por rectificar o complementar
                </f:facet>
                <p:column headerText="Tipo de rectificación">
                    <h:outputText value="#{datoRectifComplTabla.tipo}" />
                </p:column>

                <p:column headerText="Dato">
                    <h:outputText value="#{datoRectifComplTabla.nombre}" />
                </p:column>
            </p:dataTable>
            <p:spacer height="0" width="10" />

            <h:panelGrid columns="2">

                <h:panelGrid columns="2"
                             rendered="#{selectedTramiteTraParam.esRectificacion or selectedTramiteTraParam.esComplementacion}">
                    <p:spacer height="30" width="0" />
                    <p:panel style="border:0px;">
                        <h:panelGrid>
                            <p:commandButton value="#{selectedTramiteTraParam.esRectificacion?'Sel. datos a rectificar':'Sel. datos a complementar'}"
                                             icon="ui-icon-note"
                                             rendered="#{selectedTramiteTraParam.esRectificacion or selectedTramiteTraParam.esComplementacion}"
                                             immediate="true" ajax="true" disabled="#{managedBeanParam.banderaVerTramitePorAsociar}"
                                             oncomplete="seleccionDatosRectificarWV.show();"
                                             update=":rectifComplPG,:drcForm1" 
                                             action="#{managedBeanParam.cleanRectificacionVariables}" />

                            <p:spacer height="10" width="0" />
                        </h:panelGrid>
                    </p:panel>
                </h:panelGrid>
            </h:panelGrid>
        </h:panelGrid>

        <h:panelGrid cellspacing="3" columns="3" id="btnsPredios"
                     rendered="#{!selectedTramiteTraParam.quinta}">

            <p:commandButton value="Seleccionar predios" icon="ui-icon-home"
                             id="Cons" ajax="true" immediate="true"
                             disabled="#{managedBeanParam.banderaVerTramitePorAsociar or (
                                         (selectedTramiteParam.cuarta or selectedTramiteParam.revisionAvaluo) and (
                                         !selectedTramiteTraParam.segundaEnglobe))}"
                             onstart="statusDialog2.show();" update=":cpCC:consultaPredioForm, :nuevoTramiteSolForm:btnsPredios"
                             oncomplete="consultaPrediosWV.show();statusDialog2.hide();inicializarAutotab();" >
                <f:setPropertyActionListener value="2"
                                             target="#{consultaPredio.listenerMethodIdentifier}" />
            </p:commandButton>

            <p:commandButton value="Predios seleccionados" icon="ui-icon-cart" 
                             immediate="true" id="prediosSelBtn" 
                             disabled="#{managedBeanParam.banderaVerTramitePorAsociar or (
                                         (selectedTramiteParam.cuarta or selectedTramiteParam.revisionAvaluo) and (
                                         !selectedTramiteTraParam.segundaEnglobe))}"
                             onclick="prediosSeleccionadosDlgWV.hide();
                                     prediosSeleccionadosDlgWV.show();" update=":psCC:formPS,:nuevoTramiteSolForm:btnsPredios">
            </p:commandButton>


            <p:commandButton value="Asignar predios al trámite" id="asignPrediosBtn"
                             disabled="#{managedBeanParam.banderaVerTramitePorAsociar or (
                                         (selectedTramiteParam.cuarta or selectedTramiteParam.revisionAvaluo) and (
                                         !selectedTramiteTraParam.segundaEnglobe))}"
                             action="#{managedBeanParam.adicionarPrediosAlTramite}" ajax="true"
                             rendered="#{consultaPredio.predioBloqueo}"
                             icon="ui-icon-circle-arrow-s" immediate="true" update="tblPredios">
            </p:commandButton>
        </h:panelGrid>

        <h:panelGrid columns="1" id="contenedorPredios" width="98%"
                     rendered="#{!selectedTramiteTraParam.quinta}">
            <p:dataTable var="predioTramite" id="tblPredios"
                         widgetVar="prediosTramite" paginatorPosition="bottom"
                         paginator="true" rows="10"
                         paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {CurrentPageReport} {NextPageLink} {LastPageLink}"
                         rowsPerPageTemplate="5,10,15" value="#{prediosTramiteParam}"
                         emptyMessage="No hay resultados para esta búsqueda"
                         selection="#{managedBeanParam.selectedPredioTramite}"
                         selectionMode="single"
                         rowKey="#{predioTramite.predio.numeroPredial}">

                <p:ajax event="rowSelect"
                        listener="#{managedBeanParam.buscarPrediosColindantes}"
                        update=":nuevoTramiteSolForm:contenedorPredios"
                        onstart="statusDialog2.show();" oncomplete="statusDialog2.hide();" />

                <p:ajax event="rowUnselect"
                        listener="#{managedBeanParam.reiniciarPrediosColindantes}"
                        update=":nuevoTramiteSolForm:contenedorPredios"
                        onstart="statusDialog2.show();" oncomplete="statusDialog2.hide();" />

                <f:facet name="header">
                    Predios del trámite
                </f:facet>
                <p:column>
                    <f:facet name="header">
                        <h:outputText value="Opciones" />
                    </f:facet>
                    <p:commandButton title="Quitar de la lista" icon="ui-icon-trash"
                                     action="#{managedBeanParam.removePredioFromListaPrediosTramite}"
                                     disabled="#{managedBeanParam.banderaVerTramitePorAsociar}"
                                     update=":nuevoTramiteSolForm:contenedorPredios" immediate="true">
                        <f:setPropertyActionListener value="#{predioTramite}"
                                                     target="#{managedBeanParam.selectedPredioTramite}" />
                    </p:commandButton>

                    <p:commandButton title="Marcar como principal" icon="ui-icon-star"
                                     action="#{managedBeanParam.markTramiteAsPrincipal}"
                                     disabled="#{managedBeanParam.banderaVerTramitePorAsociar}"
                                     update="tblPredios" immediate="true" id="eliminarPredioBtn"
                                     rendered="#{managedBeanParam.banderaSubtipoEnglobe}">
                        <f:setPropertyActionListener value="#{predioTramite}"
                                                     target="#{managedBeanParam.selectedPredioTramite}" />
                    </p:commandButton>
                </p:column>
                <p:column rendered="#{managedBeanParam.banderaSubtipoEnglobe}">
                    <f:facet name="header">
                        Principal
                    </f:facet>
                    <h:outputText styleClass="outputTextStyle"
                                  value="#{predioTramite.englobePrincipal}" />
                </p:column>

                <p:column>
                    <f:facet name="header">
                        Departamento
                    </f:facet>
                    <h:outputText styleClass="outputTextStyle"
                                  value="#{predioTramite.predio.departamento.nombre}" />
                </p:column>

                <p:column>
                    <f:facet name="header">
                        Municipio
                    </f:facet>
                    <h:outputText styleClass="outputTextStyle"
                                  value="#{predioTramite.predio.municipio.nombre}" />
                </p:column>

                <p:column>
                    <f:facet name="header">
                        Número predial
                    </f:facet>
                    <h:outputText styleClass="outputTextStyle"
                                  value="#{predioTramite.predio.formattedNumeroPredialCompleto}" />
                </p:column>

                <p:column>
                    <f:facet name="header">
                        Número predial <br />anterior	
                    </f:facet>
                    <h:outputText styleClass="outputTextStyle"
                                  value="#{predioTramite.predio.numeroPredialAnterior}" />
                </p:column>

            </p:dataTable>

            <h:panelGrid columns="2"
                         rendered="#{not empty managedBeanParam.selectedPredioTramite and managedBeanParam.banderaSubtipoEnglobe}">
                <h:outputLabel value="Nota:" styleClass="noteLabelStyle" />
                <h:outputText
                    value="Seleccione un predio colindante para añadirlo a la lista de predios del trámite."
                    styleClass="noteTextStyle" />
            </h:panelGrid>

            <p:dataTable var="pc" id="tblPCs" paginatorPosition="bottom"
                         paginator="true" rows="10"
                         paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {CurrentPageReport} {NextPageLink} {LastPageLink}"
                         rowsPerPageTemplate="5,10,15"
                         value="#{managedBeanParam.listaPrediosColindantes}"
                         emptyMessage="No existen predios colindantes asociados al predio seleccionado."
                         rowKey="#{pc.numeroPredial}"
                         selectionMode="single"
                         selection="#{managedBeanParam.selectedPredioColindante}"
                         rendered="#{not empty managedBeanParam.selectedPredioTramite and managedBeanParam.banderaSubtipoEnglobe}">

                <p:ajax event="rowSelect"
                        listener="#{managedBeanParam.adicionarPrediosColindantes}"
                        update=":nuevoTramiteSolForm:contenedorPredios"
                        onstart="statusDialog2.show();" oncomplete="statusDialog2.hide();" />

                <f:facet name="header">
                    Predios colindantes del predio con número predial 
                    <h:outputText
                        value="#{managedBeanParam.selectedPredioTramite.predio.formatedNumeroPredial}" />
                </f:facet>


                <p:column>
                    <f:facet name="header">
                        Número predial
                    </f:facet>

                    <h:outputText styleClass="outputTextStyle"
                                  value="#{pc.formatedNumeroPredial}" />
                </p:column>

            </p:dataTable>

        </h:panelGrid>

        <p:spacer height="10" />

        <p:outputPanel id="observacionesPanelNuevoTramite" layout="block"
                       style="text-align: left">
            <h:panelGrid columns="1">
                <h:outputLabel value="Observaciones: "
                               styleClass="outputLabelStyle" />
                <h:inputTextarea cols="180" rows="5" id="observaciones"
                                 onkeydown="controlarNroChars(this, 2000, true)"
                                 onkeyup="controlarNroChars(this, 2000, true)"
                                 value="#{selectedTramiteTraParam.observacionesRadicacion}" />
            </h:panelGrid>
        </p:outputPanel>


        <p:outputPanel id="btnsPanelNuevoTramite" layout="block"
                       style="text-align: right">

            <p:commandButton value="Guardar trámite" icon="ui-icon-disk"
                             disabled="#{managedBeanParam.banderaVerTramitePorAsociar}"
                             action="#{managedBeanParam.guardarTramiteNuevo}" ajax="true"					
                             update="#{updatesBotonGuardarTramiteParam}, :nuevoTramiteSolForm"
                             oncomplete="document.getElementById('nuevoTramiteSolForm').focus();handleCompleteSIC(xhr, status, args, adicionarTramiteTramiteWV, false);" />

            <p:spacer height="13" width="13" />
        </p:outputPanel>

    </h:panelGrid>
</h:form>